.area _DATA
.area _CODE

.include "cpctelera.h.s"
.include "person.h.s"
.include "hero.h.s"

;;Functions
.globl drawNextLevel

;;Sprites
.globl _number_1
.globl _number_2
.globl _number_3
.globl _number_4
.globl _number_5
.globl _number_6
.globl _number_7
.globl _number_8
.globl _number_9

;;Goal Data
goal_x:     .db #0      ;;|
goal_y:     .db #0      ;;\Screen position

num_haters: .db #0      ;;|      
num_lovers:	.db #0      ;;\Number of real people

goal_haters:.db #0      ;;|
goal_lovers:.db #0      ;;\Number of people to complete the goal

timer:	    	.db #0
goal_complete:  .db #1  
next_goal:      .db #0
goal_end:       .db #0
goal_next_level:.db #0

goal_table:
	;;  hat	 lov  n_lev
    .db #02, #01, #00   ;;|
    .db #02, #02, #00   ;;|
    .db #03, #02, #00   ;;|
    .db #04, #02, #01   ;;\Next level
    .db #04, #03, #00   ;;|
    .db #04, #04, #00   ;;|
    .db #04, #02, #00   ;;|
    .db #04, #01, #01   ;;\Next level
    .db #04, #07, #00   ;;|
    .db #04, #04, #00   ;;|
    .db #07, #05, #00   ;;|
    .db #07, #07, #01   ;;\Next level
    .db #08, #08, #00   ;;|
    .db #06, #09, #00   ;;|
    .db #03, #09, #00   ;;|
    .db #07, #01, #01   ;;\Next level
    .db #07, #07, #00   ;;|
    .db #07, #05, #00   ;;|
    .db #07, #07, #00   ;;|
    .db #05, #07, #01   ;;\Next level
    .db #09, #09, #00   ;;|
    .db #0xFF



;;==================================================================================
;;Initialize the goals
;;==================================================================================
goal_create::
    ld a, #1                    ;;|
    ld (goal_complete), a       ;;\Initialize the state of the goal

    ld a, #999999                ;;|
    ld (timer), a                ;;\Initialize the timer

    ld a, #0                    ;;|
    ld (next_goal), a           ;;\Initialize the value of next goal

    ld (goal_end), a            ;;not goals end
    ld (goal_next_level), a     ;;not next level
    
    call getGoal                ;;Create a new goal
    ret

;;==================================================================================
;;Update the goal 
;;==================================================================================
goal_update::
    ld a, (timer)               ;;|
    dec a                       ;;|
    ld (timer), a               ;;\Decremento el contador

    call getNumLovers			;;|Update
    ld a, b						;;|number
    ld (num_lovers), a			;;\lovers

    call getNumHaters			;;|Update
    ld a, b						;;|number
    ld (num_haters), a			;;\haters

    call completeGoal           ;;Check if the goal is complete
    ret
;;==================================================================================
;;Create a new goal whit values
;;Initialize -> timer = 500,   goal_haters = random,   goal_lovers = random
;;==================================================================================
getGoal::
    ld hl, #goal_table          ;;|
    ld a, (next_goal)           ;;|
    ld c, a                     ;;|
    ld b, #0                    ;;|
    add hl, bc                  ;;\Cargo next_goal en hl
   
    call newLevel
    call endGoals

    ld a, #1                    ;;|
    ld (goal_complete), a       ;;\Initialize the state of the goal

    ld a, #99999                ;;|
    ld (timer), a               ;;\Initialize the timer
  
	ld a, #0					;;| 
    ld (goal_haters), a         ;;|
    ld (goal_lovers), a         ;;\ Initialize the value of the goal

    call getNumLovers			;;|Initialize
    ld a, b						;;|number
    ld (num_lovers), a			;;\lovers

    call getNumHaters			;;|Initialize
    ld a, b						;;|number
    ld (num_haters), a			;;\haters
    
    ld a, (hl)                  ;;|hl = 0
    ld (goal_haters), a         ;;\Obtener numero de haters

    inc hl                      ;;hl = 1

    ld a, (hl)                  ;;|
    ld (goal_lovers), a         ;;\Obtener numero de lovers

    dec hl                      ;;hl = 0
	ret
;;==================================================================================
;;Check if player has complete a goal
;; 0 -> no	   1 -> yes
;;==================================================================================
completeGoal:
	ld a, (num_haters)			;;|
	ld b, a						;;|
	ld a, (goal_haters)			;;|
	cp b						;;|
	jr nz, noGoalComplete		;;\Compruebo que se cumple la goal haters

	ld a, (num_lovers)			;;|
	ld b, a						;;|
	ld a, (goal_lovers)			;;|
	cp b						;;|
	jr nz, noGoalComplete		;;\Compruebo que se cumple la goal lovers

	ld a, #1					;;|
	ld (goal_complete), a		;;\Goal complete
    call nextGoal               ;;Pass to the next goal
	ret

	noGoalComplete:
		ld a, #0				;;|
		ld (goal_complete), a	;;\Goal not complete
	ret
;;==================================================================================
;;Extern call for get the value of goal_complete
;; RETURN A = goal_complete
;; 0 -> no	   1 -> yes
;;==================================================================================
getGoalComplete::
	    ld a, (goal_complete)
	ret
;;================================================================================== 
;;Extern call for get the timer
;;==================================================================================
getTimer::
       ld a, (timer)
    ret
;;================================================================================== 
;;Extern call for draw the goals
;;==================================================================================  
drawGoals::
    call drawGoalHater
    call drawGoalLover
    ret
;;================================================================================== 
;;Draw the goals
;;==================================================================================
drawGoalHater::
    ;;Calculate Screen position
	ld de, #0xC000				    ;;Calculate Screen position
    ld a, (goal_x)
	ld c, a     					;;C=person_x
    ld a, (goal_y)          
	ld b, a     					;;B=person_y

	call cpct_getScreenPtr_asm  	;;HL = Pointer to screen

	ex de, hl
	ld bc, #0x0C06			    	;;12x12
    ld a, (goal_haters)
    
    cp #1
    jr z, drawOneHater

    cp #2
    jr z, drawTwoHater

    cp #3
    jr z, drawThreeHater
       
    cp #4
    jr z, drawForHater

    cp #5
    jr z, drawFiveHater

    cp #6
    jr z, drawSixHater

    cp #7
    jr z, drawSevenHater

    cp #8
    jr z, drawEightHater
       
    ;drawNineHater:
        ld	hl, #_number_9
        call cpct_drawSprite_asm
    ret
    
    drawOneHater:
        ld	hl, #_number_1
        call cpct_drawSprite_asm
    ret

    drawTwoHater:
        ld	hl, #_number_2
        call cpct_drawSprite_asm
    ret

    drawThreeHater:
        ld	hl, #_number_3
        call cpct_drawSprite_asm
    ret

    drawForHater:
        ld	hl, #_number_4
        call cpct_drawSprite_asm
    ret

    drawFiveHater:
        ld	hl, #_number_5
        call cpct_drawSprite_asm
    ret

    drawSixHater:
        ld	hl, #_number_6
        call cpct_drawSprite_asm
    ret

    drawSevenHater:
        ld	hl, #_number_7
        call cpct_drawSprite_asm
    ret
    
    drawEightHater:
        ld	hl, #_number_8
        call cpct_drawSprite_asm
    ret

;;================================================================================== 
;;Draw the goals
;;==================================================================================
drawGoalLover:
    ;;Calculate Screen position
	ld de, #0xC000				    ;;Calculate Screen position
    ld a, (goal_x)
	ld c, a     					;;C=person_x
    ld a, (goal_y)          
    add a, #14                      ;;Draw down
	ld b, a     					;;B=person_y

	call cpct_getScreenPtr_asm  	;;HL = Pointer to screen

	ex de, hl
	ld bc, #0x0C06			    	;;12x12 
    ld a, (goal_lovers)
   
    cp #1
    jr z, drawOneLover

    cp #2
    jr z, drawTwoLover

    cp #3
    jr z, drawThreeLover

    cp #4
    jr z, drawForLover

    cp #5
    jr z, drawFiveLover

    cp #6
    jr z, drawSixLover

    cp #7
    jr z, drawSevenLover

    cp #8
    jr z, drawEightLover
    
    ;;drawNineLover:
        ld	hl, #_number_9
        call cpct_drawSprite_asm
    ret
    
    drawOneLover:
        ld	hl, #_number_1
        call cpct_drawSprite_asm
    ret

    drawTwoLover:
        ld	hl, #_number_2
        call cpct_drawSprite_asm
    ret

    drawThreeLover:
        ld	hl, #_number_3
        call cpct_drawSprite_asm
    ret

    drawForLover:
        ld	hl, #_number_4
        call cpct_drawSprite_asm
    ret

    drawFiveLover:
        ld	hl, #_number_5
        call cpct_drawSprite_asm
    ret

    drawSixLover:
        ld	hl, #_number_6
        call cpct_drawSprite_asm
    ret

    drawSevenLover:
        ld	hl, #_number_7
        call cpct_drawSprite_asm
    ret

    drawEightLover:
        ld	hl, #_number_8
        call cpct_drawSprite_asm
    ret
;;================================================================================== 
;;Next goal 
;;==================================================================================
nextGoal::
    ld a, (next_goal)           ;;|
    add a, #3                   ;;|
    ld (next_goal), a           ;;\Load the next goal

    call getGoal                ;;Create a goal
    ret
;;================================================================================== 
;;Check if there aren't more goals
;;  RETURN A =   0 -> no  1 -> yes
;;==================================================================================
endGoals:
    ld a, (hl)						;;|A = next_goal
	cp #0xFF					
	jr z, winner
    	ld a, #0
        ld (goal_end), a
    ret	
    winner:
        ld a, #1
        ld (goal_end), a
    ret
;;==================================================================================
;;Check if is winner
;;==================================================================================
isWinner::
        ld a, (goal_end)
    ret
;;================================================================================== 
;;Check if the level is ended
;;==================================================================================
newLevel::
    inc hl                          ;;hl = 1
    inc hl                          ;;hl = 2
    ld a, (hl)				        ;;|A = goal_next_level
	cp #1					        ;;|
	jr z, nextLevel                 
        dec hl                      ;;| 
        dec hl                      ;;\Reestart hl = 0
    ret	
    nextLevel:                       
        dec hl                      ;;|
        dec hl                      ;;\Reestart hl = 0
        push hl
        call drawNextLevel
        pop hl
    ret


