.area _DATA
.area _CODE

.include "cpctelera.h.s"
.include "person.h.s"
.include "hero.h.s"

;;METER Data
haters_x: .db 7
haters_y: .db 5
lovers_x: .db 7
lovers_y: .db 13
num_haters: .db #0
num_lovers:	.db #0

;;==================================================================================
;;New meter
;;==================================================================================
meter_create::
	ld a, #0					;;| Initialize 
	ld (num_haters), a			;;|	the 
	ld (num_lovers), a			;;\ counter
	ret
;;==================================================================================
;;Erase the meter
;;==================================================================================
meter_erase::
	call eraseMeterHaters
	call eraseMeterLovers
	ret
;;==================================================================================
;;Update the counter 
;;==================================================================================
meter_update::
	ld a, #7					;;|
	ld (haters_x), a			;;|
	ld (lovers_x), a			;;\ Set _x

	call getNumLovers			;;|Update
	ld a, b						;;|lovers
	ld (num_lovers), a			;;\meter

	call getNumHaters			;;|Update
	ld a, b						;;|haters
	ld (num_haters), a			;;\meter
    
	ret
;;==================================================================================
;;Draw the meters
;;==================================================================================
meter_draw:: 
	call drawMeterHaters
	call drawMeterLovers 
    ret
;;==================================================================================
;;	Draw the haters meter 
;;==================================================================================
drawMeterHaters:
	meter_haters:
		ld a, (num_haters)
		cp #0
		jr z, finMeterHaters 
			;; Calculate Screen position
			ld de, #0xC000					;;Video memory

			ld a, (haters_x)				;;|
			ld c, a							;;\ C = meter_x

			ld a, (haters_y)				;;|
			ld b, a							;;\ B = meter_y

			call cpct_getScreenPtr_asm		;;Get pointer to screen
			ex de, hl

			;; Draw a box
			ld 	a, #0x30					;;PALETTE Cian
			ld bc, #0x0101					;;1x2
			call cpct_drawSolidBox_asm
			
			ld a, (num_haters)			;;A = num_haters
			dec a						;;A --
			ld (num_haters), a			;;num_haters --

			ld a, (haters_x)				;;A = meter_x
			add #2							;;A = A + 2
			ld (haters_x), a				;;meter_x = meter_x + 2
			jr meter_haters					;;repetir hasta haters = 0		
		finMeterHaters:
		ret
	ret	
;;==================================================================================
;;	Draw the haters meter 
;;==================================================================================
drawMeterLovers:
	meter_lovers:
		ld a, (num_lovers)
		cp #0
		jr z, finMeterLovers 
			;; Calculate Screen position
			ld de, #0xC000				;;Video memory

			ld a, (lovers_x)				;;|
			ld c, a							;;\ C = lovers_x

			ld a, (lovers_y)			;;|
			add #5						;;| 
			ld b, a						;;\ Draw down

			call cpct_getScreenPtr_asm	;;Get pointer to screen
			ex de, hl

			;; Draw a box
			ld a, #0xf0					;;PALETTE Green
			ld bc, #0x0101				;;1x2
			call cpct_drawSolidBox_asm
			
			ld a, (num_lovers)			;;A = num_haters
			dec a						;;A --
			ld (num_lovers), a			;;num_haters --

			ld a, (lovers_x)				;;A = meter_x
			add #2							;;A = A + 2
			ld (lovers_x), a				;;meter_x = meter_x + 4
			jr meter_lovers					;;repetir hasta haters = 0		
		finMeterLovers:
	ret
;;==================================================================================
;;Erase the meter haters
;;==================================================================================
eraseMeterHaters:
	;; Calculate Screen position
	ld de, #0xC000				;;Video memory

	ld a, (haters_x)				;;|
	ld c, a							;;\ C = meter_x

	ld a, (haters_y)				;;|
	ld b, a							;;\ B = meter_y

	call cpct_getScreenPtr_asm	;;Get pointer to screen
	ex de, hl

	;; Draw a box
	ld a, #0x00					;;PALETTE Black
	ld bc, #0x0240				;;80x2 -> 2x80 -> 1x80
	call cpct_drawSolidBox_asm
	ret

;;==================================================================================
;;Erase the meter lovers
;;==================================================================================
eraseMeterLovers:
	;; Calculate Screen position
	ld de, #0xC000				;;Video memory

	ld a, (lovers_x)				;;|
	ld c, a							;;\ C = meter_x

	ld a, (lovers_y)				;;|
	add #4							;;|
	ld b, a							;;\ B = meter_y

	call cpct_getScreenPtr_asm	;;Get pointer to screen
	ex de, hl

	;; Draw a box
	ld a, #0x00					;;PALETTE Black
	ld bc, #0x0240				;;80x2 -> 2x80 -> 1x80
	call cpct_drawSolidBox_asm
	ret
